/***************************************************************************
 *   $Id: htmltpl.h,v 1.1.1.1 2011-11-17 16:42:29 scg Exp $
 *                                                                         *
 *   (C)2011 St(u)dio of Computer Games                                    *
 *   Alexander Ozumenko <a.ozumenko@gmail.com>                             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef __HTMLTPL_
#define __HTMLTPL_



/**
 * Templae section
 */

struct tpl;


/* create template from file */
struct tpl *tpl_create(void);

/* load template from file */
int tpl_parse_file(struct tpl *tpl, const char *filename);

/* parse text buffer */
int tpl_parse_text(struct tpl *tpl, const char *text);

/* release template */
void tpl_release(struct tpl *tpl);

/* get template enviroment */
struct enviroment *tpl_get_enviroment(struct tpl *tpl);

/* output template */
int tpl_output(struct tpl *tpl, FILE *stream);

/* get a last error */
const char *tpl_error(struct tpl *tpl);



/**
 * Variables interface section
 */

struct enviroment;
struct variable;


/* get enviroment root HASH */
struct variable *enviroment_get_root(struct enviroment *env);

/* get last enviroment error */
int enviroment_errno(struct enviroment *env);

/* SCALAR */
struct variable *variable_scalar(struct enviroment *env, const char *value);

/* ARRAY */
struct variable *variable_array(struct enviroment *env, ...);
struct variable *variable_array_push(struct variable *var, ...);

/* HASH */
struct variable *variable_hash(struct enviroment *env, ...);
struct variable *variable_hash_set(struct variable *var, ...);

/* release allocated variable */
void variable_release(struct variable *var);



#endif /* __HTMLTPL */
